<template>
    <v-row v-resize="onResize" class="pa-4">

        <v-col :cols="7">

            <ErrorComponent :error-value="error" class="w"/>
            <SuccessComponent :success-value="success" class="w"/>
            <div class="display">
                <v-form>
                    <v-row>
                        <v-col>
                            <v-text-field v-model="fWidth" label="Width" required @input="onChange"/>
                        </v-col>
                        <v-col>
                            <v-text-field v-model="fHeight" label="Height" required @input="onChange"/>
                        </v-col>
                        <v-col>
                            <v-btn @click="Upload" color="primary">{{ !hasExistingFloorplan ? 'Create' : 'Update' }}</v-btn>
                        </v-col>
                    </v-row>
                    <v-row id="parent" class="parent">
                        <div :style="Style" class="parent">
                            <vue-base64-file-upload
                                    v-if="!hasExistingFloorplan"
                                    class="image"
                                    accept="image/png,image/jpeg"
                                    image-class="v1-image"
                                    input-class="v1-input"
                                    :max-size="5"
                                    @size-exceeded="onSizeExceeded"
                                    @load="onLoad"
                                    @change="onChange"/>
                            <img v-else class="max" :src="image">
                            <canvas v-show="image.length> 1" id='canvas' class="max left0">

                            </canvas>
                        </div>
                    </v-row>

                </v-form>

            </div>
        </v-col>
        <v-col :cols="5">

            <div class="label">Exits</div>
            <v-jsoneditor v-model="exits" :options="options" :plus="false" height="400px" @input="onChange"/>
            <div class="label">Zones</div>
            <v-jsoneditor v-model="zones" :options="options" :plus="false" height="400px" @input="onChange"/>
        </v-col>
    </v-row>
</template>

<style lang='scss' scoped>

    .left0 {
        left: 0;
    }

    .max {
        position: absolute;
        width: 100%;
        height: 100%;
    }

    .image {
        position: absolute;
        width: 100%;
        height: 100%;
    }

    .parent {
        position: relative;
    }
</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {core, coreApi} from "../../init";
    import VJsoneditor from 'v-jsoneditor';
    import VueBase64FileUpload from 'vue-base64-file-upload'
    import ErrorComponent from "../../components/ErrorComponent.vue";
    import SuccessComponent from "../../components/SuccessComponent.vue";
    import {Initializable} from "../../mixins/Initializable";
    import {InputExit, ExitMapper} from "../../../../classLibrary/Convert/InputExit";
    import {InputZone, ZoneMapper} from "../../../../classLibrary/Convert/InputZone";
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import {Drawer} from "../../../../classLibrary/Drawer";
    import {Q} from "../../../../classLibrary/Geometry/Quad";
    import {FloorPlanMapper} from "../../../../classLibrary/Convert/InputFloorPlan";
    import {P} from "../../../../classLibrary/Geometry/Point";
    import { FloorPlanFullResponse } from '../../../../classLibrary/core/floorPlanFullResponse';
    import { FloorResponse } from '../../../../classLibrary/core/floorResponse';
    import { ZoneResponse } from '../../../../classLibrary/core/zoneResponse';


    interface FloorPlanMixin extends Validable, Initializable {
    }

    @Component({
        components: {
            VJsoneditor,
            VueBase64FileUpload,
            ErrorComponent,
            SuccessComponent
        }
    })
    export default class EditFloorPlan extends Mixins<FloorPlanMixin>(Validable, Initializable) {

        floorId: string = "";
        hasExistingFloorplan = false

        exits: { [s: string]: InputExit } = {
            "C to D": {
                "a1": "Zone C",
                "a2": "Zone D",
                "p": [[1.4, 4], [2.4, 4]]
            }
        };
        zones: { [s: string]: InputZone } = {
            "Zone A": {
                danger: false,
                tracked: true,
                color: "#f00",
                meta: {},
                maps: [
                    [[3, 0], [8, 0], [8, 4], [3, 4]]
                ]
            }
        };


        draw: Drawer = new Drawer(0, 0, 0, 0, {} as CanvasRenderingContext2D);
        options = {
            mode: "code",
            onChange: this.onChange
        };


        async init() {
            this.floorId = this.$route.params.id;
            const r = await coreApi.Get<FloorResponse>(`Floor/${this.floorId}`);
            if (!r.success) await this.$router.push("not found")

            const fp = r.Ok!.latestFloorPlan.id;
            if (fp) {
                // load latest floorplan
                const fr = await coreApi.Get<FloorPlanFullResponse>(`FloorPlan/${this.floorId}/${fp}`);
                if (!fr.success) this.err = fr.error!;

                this.image = fr.Ok!.info.image;
                this.fWidth = fr.Ok!.info.width.toString();
                this.fHeight = fr.Ok!.info.height.toString();
                this.exits = fr.Ok!.exits
                    .reduce((map, exit) => {
                        map[exit.exitId] = ExitMapper.From(exit)
                        return map
                    }, {})
                const zonesData = fr.Ok!.info.zoneData
                this.zones = fr.Ok!.areas
                    .reduce((map, area) => {
                        map[area.areaId] = ZoneMapper.From(area, zonesData[area.areaId])
                        return map
                    }, {})

                this.hasExistingFloorplan = true

                this.drawOnCanvas();
            }
        }

        async resetCanvas() {
            const c = document.getElementById("canvas") as HTMLCanvasElement;

            const ww = window.innerWidth;
            const wh = window.innerHeight;

            const w = ww/2;
            const h = wh/2;

            c.width = w.ToFloat();
            c.height = h.ToFloat();


            const ctx = c.getContext("2d")!;
            this.draw = new Drawer(this.W, this.H, w.ToFloat(), h.ToFloat(), ctx);

        }

        async drawOnCanvas() {
            this.draw.UpdateMap(this.W, this.H).Clear();
            const fpR = FloorPlanMapper.To(this.zones, this.exits, this.H, this.W, this.image, "hey");

            const color = ["red", "green", "blue", "cyan", "yellow", "purple", "black", "orange"];


            const colors = fpR.mainRequest.areas
                .Map((a, i) => {
                        const c = color[i % color.length];
                        a.maps.Each(m => {
                            const q = Q(m);
                            this.draw.DrawArea(q.Quad, a.areaId, c, (fpR.zoneInfo as any)[a.areaId].danger)
                        });
                        return [a.areaId, c];
                    }
                )
                .AsValue(([id, c]) => id)
                .MapValue(([k, v]) => v as string);
            const c = Object.fromEntries(colors) as { [s: string]: string };

            fpR.mainRequest.exits.Each(e => {
                const p1 = P(e.pt1).Point;
                const p2 = P(e.pt2).Point;
                this.draw.DrawExit([p1, p2], c[e.area1], c[e.area2]);
            });
        }

        async mountInit() {
            this.onResize();

        }

        onChange() {
            this.drawOnCanvas();
        }

        onLoad(dataUri: string) {
            this.image = dataUri;
        }

        onSizeExceeded(size: number) {
            this.err = `Image ${size}Mb size exceeds limits of 5Mb!`;
        }

        image = "";
        iwidth = 0;
        fWidth = "10";
        fHeight = "5";

        onResize() {
            this.iwidth = document.getElementById("parent")!.getBoundingClientRect().width;
            this.resetCanvas();
            this.drawOnCanvas()
        }


        get H() {
            try {
                return this.fHeight.ToFloat()
            } catch {
                return 5;

            }
        }

        get W() {
            try {
                return this.fWidth.ToFloat()
            } catch {
                return 5;

            }
        }

        get leftWidth(): number {
            return this.iwidth * 0.9;
        }

        get Style() {
            return {
                transition: "width 0.4s, height 0.4s",
                width: this.leftWidth + "px",
                height: this.leftWidth / this.W * this.H + "px",
            }
        }


        async Upload() {

            if (this.image.IsEmpty()) {
                this.err = "Please upload floor plan";
                return
            }

            if (!core.IsNumber(this.fWidth, true)) {
                this.err = "Please enter numerical width";
                return
            }


            if (!core.IsNumber(this.fHeight, true)) {
                this.err = "Please enter numerical height";
                return
            }


            const req = FloorPlanMapper.To(this.zones, this.exits, this.H, this.W, this.image, "bytee");

            const res = await coreApi.Post(`FloorPlan/${this.floorId}`, req);

            if (res.Ok) {
                const action = !this.hasExistingFloorplan ? 'created' : 'updated'
                this.ok = "Successfully created floorplan"
            } else {
                this.err = res.error!;
            }
        }
    }

</script>
